%define anolis_release 1
%bcond_without tests

Name:           libuv
Epoch:          1
Version:        1.48.0
Release:        %{anolis_release}%{?dist}
Summary:        Platform layer for node.js
License:        MIT AND CC-BY-4.0 AND ISC AND BSD-2-Clause
URL:            https://libuv.org/
Source0:        https://dist.libuv.org/dist/v%{version}/libuv-v%{version}.tar.gz
Source1:        libuv.abignore

BuildRequires:  cmake
BuildRequires:  gcc
# Documentation
BuildRequires:  make
BuildRequires:  python3-sphinx

%description
libuv is a new platform layer for Node. Its purpose is to abstract IOCP on
Windows and libev on Unix systems. We intend to eventually contain all platform
differences in this library.

%package devel
Summary:        Development libraries for libuv
Requires:       %{name} = %{EVR}

%description devel
Development libraries for libuv

%package static
Summary:        Platform layer for node.js - static library
Requires:       %{name}-devel = %{EVR}

%description static
Static library (.a) version of libuv.

%package doc
Summary:        Documentation files for %{name}
Requires:       %{name} = %{EVR}
BuildArch:      noarch

%description    doc
The %{name}-doc package contains documentation files for %{name}.

%prep
%autosetup -p1 -n %{name}-v%{version} 

%build
%cmake
%cmake_build

# Build Documentation
make -C docs man

%install
%cmake_install

# install documentation
mkdir -p  %{buildroot}/%{_mandir}/man1/
install -p -m 644 docs/build/man/libuv.1 %{buildroot}/%{_mandir}/man1/
mkdir -p %{buildroot}%{_libdir}/libuv/
install -Dm0644 -t %{buildroot}%{_libdir}/libuv/ %{SOURCE1}
# Remove packaged license files
rm %{buildroot}/%{_docdir}/libuv/LICENSE
rm %{buildroot}/%{_docdir}/libuv/LICENSE-extra

%generate_compatibility_deps

%check
%if %{with tests}
env UV_TEST_TIMEOUT_MULTIPLIER=50 ./%{__cmake_builddir}/uv_run_tests
env UV_TEST_TIMEOUT_MULTIPLIER=50 ./%{__cmake_builddir}/uv_run_tests_a
%endif

%files
%dir %{abidir}
%license LICENSE LICENSE-docs LICENSE-extra
%{_libdir}/%{name}.so.1
%{_libdir}/%{name}.so.1.*
%{abidir}/%{name}.dump
%dir %{_libdir}/%{name}
%{_libdir}/libuv/libuv.abignore
%{_mandir}/man1/%{name}.1*

%files devel
%{_libdir}/%{name}.so
%{_libdir}/pkgconfig/%{name}.pc
%{_includedir}/uv.h
%{_includedir}/uv/
%dir %{_libdir}/cmake/%{name}
%{_libdir}/cmake/%{name}/*.cmake

%files static
%{_libdir}/%{name}.a
%{_libdir}/pkgconfig/%{name}-static.pc

%files doc
%doc README.md AUTHORS CONTRIBUTING.md MAINTAINERS.md SUPPORTED_PLATFORMS.md
%doc ChangeLog

%changelog
* Sun Feb 11 2024 Funda Wang <fundawang@yeah.net> - 1:1.48.0-1
- New version 1.48.0

* Thu Apr 13 2023 Guyu Wang <guyu.wgy@linux.alibaba.com> - 1:1.44.2-2
- Optimise spec file

* Wed Mar 1 2023 Guyu Wang <guyu.wgy@linux.alibaba.com> - 1:1.44.2-1
- Update to v1.44.2

* Wed Oct 19 2022 mgb01105731 <mgb01105731@alibaba-inc.com> - 1:1.44.0-2
- optimise spec file & add doc package

* Wed Mar 09 2022 Yuanhong Peng <yummypeng@linux.alibaba.com> 1:1.44.0-1
- Init from upstream v1.44.0
